

InitShadow proto :DWORD, :DWORD
DestroyShadow proto 
.data
; ************************************
szClassName			db			"Shadow Window",0
szUserDll			db			"USER32.DLL",0
szULWText			db			"UpdateLayeredWindow",0
stShadowClient			RECT			<-8,-30,30,46> ; <14,14,46,46> Makes a perfect rect but I am compensating for the radius 
ShadowEnable			db			TRUE

.data?
; ************************************
uPdateLayeredWindow		dd			?
hShadowBitmap			dd			?
hShadowInstance			dd			?

.const
; ************************************

WS_EX_LAYERED			equ			00080000h

.code
InitShadow proc _hInstance:DWORD, _identifier:DWORD
LOCAL	wc:WNDCLASSEX
	invoke	GetModuleHandle, addr szUserDll
	invoke	GetProcAddress, eax, addr szULWText
	or	eax, eax
	jnz	@f
	mov	ShadowEnable, FALSE
	ret
@@:
	mov	uPdateLayeredWindow, eax
	mov	wc.cbSize,SIZEOF WNDCLASSEX
	mov	wc.style, NULL
	mov	wc.lpfnWndProc, OFFSET DefWindowProc
	mov	wc.cbClsExtra,NULL
	mov	wc.cbWndExtra,NULL
	push	_hInstance
	pop	wc.hInstance
	push	_hInstance
	pop	hShadowInstance
	mov	wc.hbrBackground,COLOR_WINDOW+1
	mov	wc.lpszMenuName,NULL
	mov	wc.lpszClassName,OFFSET szClassName
	invoke	LoadIcon,NULL,IDI_APPLICATION
	mov	wc.hIcon,eax
	mov	wc.hIconSm,eax
	invoke	LoadCursor,NULL,IDC_ARROW
	mov	wc.hCursor,eax
	invoke	RegisterClassEx, addr wc

	;invoke	LoadBitmap, _hInstance, _identifier
	mov	hShadowBitmap, eax
ret
InitShadow endp
; ************************************
DestroyShadow proc
	invoke	DeleteObject, hShadowBitmap
ret
DestroyShadow endp
; ************************************

CreateShadow proc _hInstance:DWORD
;Window should set overlapped style
	INVOKE CreateWindowEx,  WS_EX_TRANSPARENT , \
	   OFFSET szClassName, NULL, WS_VISIBLE or WS_CLIPSIBLINGS or WS_BORDER or SS_NOTIFY, 0, 0, 280, 175,NULL,NULL,_hInstance,NULL
	push	eax 
	invoke ShowWindow, eax,SW_SHOW ;SW_SHOWDEFAULT	
	pop	eax
ret
						
CreateShadow endp

; ************************************
ProcessShadowProc proc hWnd:DWORD, uMsg:DWORD

LOCAL	@rect:RECT
LOCAL	@hMenu:DWORD
	cmp	ShadowEnable, TRUE
	je	@f
	ret
@@:	.IF uMsg==WM_INITDIALOG

		invoke	CreateShadow, hShadowInstance
		invoke	SetWindowLong, hWnd, GWL_USERDATA, eax   ;GWL_WNDPROC or GWL_USERDATA ???
		invoke	GetWindowRect, hWnd, addr @rect
		invoke	GetWindowLong, hWnd, GWL_USERDATA
	;	invoke	AdjustShadow, hWnd, eax, hShadowBitmap
	invoke	GetWindowRect, hWnd, addr @rect
		mov	eax, stShadowClient.left
		sub	@rect.left, eax
		mov	eax, stShadowClient.top
		sub	@rect.top, eax
		invoke	GetWindowLong, hWnd, GWL_WNDPROC
		invoke	SetWindowPos, eax, HWND_TOP, @rect.left, @rect.top,0,0, SWP_NOSIZE or SWP_NOACTIVATE
	.elseif uMsg==WM_SIZE
		invoke	GetWindowRect, hWnd, addr @rect
		invoke	GetWindowLong, hWnd, GWL_USERDATA
	;	invoke	AdjustShadow, hWnd, eax, hShadowBitmap
	.elseif uMsg==WM_MOVE
		invoke	GetWindowRect, hWnd, addr @rect
		mov	eax, stShadowClient.left
		sub	@rect.left, eax
		mov	eax, stShadowClient.top
		sub	@rect.top, eax
		invoke	GetWindowLong, hWnd,GWL_USERDATA
		invoke	SetWindowPos, eax, HWND_TOP, @rect.left, @rect.top,0,0, SWP_NOSIZE or SWP_NOACTIVATE
	.elseif uMsg==WM_CLOSE
		invoke	GetWindowLong, hWnd, GWL_USERDATA
		invoke	DestroyWindow, eax
	.ELSE
		xor	eax, eax
		ret
	.ENDIF
FUN_RET:
xor	eax,eax
inc	eax
ret
ProcessShadowProc endp
; ************************************
